// MidiFishDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MidiFish.h"
#include "MidiFishDlg.h"
#include "doc.h"
#include "midi.h"
#include "ctrlmapdlg.h"
#include "keymapdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



MidiFishDlg::MidiFishDlg(CWnd *pParent /*=NULL*/)
	: CDialog(MidiFishDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(MidiFishDlg)
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	mDoc = new Doc;

	mDisableTimer = false;
}



MidiFishDlg::~MidiFishDlg()
{
	if (mDoc)
		delete mDoc;
}



void MidiFishDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MidiFishDlg)
	DDX_Control(pDX, IDC_PORT_OUT4_CHANNEL, mOut4Channel);
	DDX_Control(pDX, IDC_PORT_OUT3_CHANNEL, mOut3Channel);
	DDX_Control(pDX, IDC_PORT_OUT2_CHANNEL, mOut2Channel);
	DDX_Control(pDX, IDC_PORT_OUT1_CHANNEL, mOut1Channel);
	DDX_Control(pDX, IDC_PORT_IN2_CHANNEL, mIn2Channel);
	DDX_Control(pDX, IDC_PORT_IN1_CHANNEL, mIn1Channel);
	DDX_Control(pDX, IDC_KEY_ACTIVE, mKeyActive);
	DDX_Control(pDX, IDC_CONTROLLER_ACTIVE, mCtrlActive);
	DDX_Control(pDX, IDC_KEY_MAPPING, mKeyMap);
	DDX_Control(pDX, IDC_CONTROLLER_MAPPING, mCtrlMap);
	DDX_Control(pDX, IDC_PORT_OUT4_ENABLE, mOut4Enable);
	DDX_Control(pDX, IDC_PORT_OUT4, mOut4);
	DDX_Control(pDX, IDC_PORT_OUT3_ENABLE, mOut3Enable);
	DDX_Control(pDX, IDC_PORT_OUT3, mOut3);
	DDX_Control(pDX, IDC_PORT_OUT2_ENABLE, mOut2Enable);
	DDX_Control(pDX, IDC_PORT_OUT2, mOut2);
	DDX_Control(pDX, IDC_PORT_OUT1_ENABLE, mOut1Enable);
	DDX_Control(pDX, IDC_PORT_OUT1, mOut1);
	DDX_Control(pDX, IDC_PORT_IN2_ENABLE, mIn2Enable);
	DDX_Control(pDX, IDC_PORT_IN1_ENABLE, mIn1Enable);
	DDX_Control(pDX, IDC_PORT_IN2, mIn2);
	DDX_Control(pDX, IDC_PORT_IN1, mIn1);
	//}}AFX_DATA_MAP

	if (!pDX->m_bSaveAndValidate) {
		mKeyMap.SetTabStops(23);
		mCtrlMap.SetTabStops(56);

		mDoc->mIn[0]->init_controls(&mIn1, &mIn1Channel, &mIn1Enable);
		mDoc->mIn[1]->init_controls(&mIn2, &mIn2Channel, &mIn2Enable);

		mDoc->mOut[0]->init_controls(&mOut1, &mOut1Channel, &mOut1Enable);
		mDoc->mOut[1]->init_controls(&mOut2, &mOut2Channel, &mOut2Enable);
		mDoc->mOut[2]->init_controls(&mOut3, &mOut3Channel, &mOut3Enable);
		mDoc->mOut[3]->init_controls(&mOut4, &mOut4Channel, &mOut4Enable);

		mDoc->init_controls(&mKeyMap, &mKeyActive, &mCtrlMap, &mCtrlActive);
	}
}



BEGIN_MESSAGE_MAP(MidiFishDlg, CDialog)
	//{{AFX_MSG_MAP(MidiFishDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_SAVEAS, OnSaveas)
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_WM_LBUTTONDOWN()
	ON_CBN_SELCHANGE(IDC_PORT_IN1, OnSelchangePortIn1)
	ON_BN_CLICKED(IDC_PORT_IN1_ENABLE, OnPortIn1Enable)
	ON_CBN_SELCHANGE(IDC_PORT_IN2, OnSelchangePortIn2)
	ON_BN_CLICKED(IDC_PORT_IN2_ENABLE, OnPortIn2Enable)
	ON_CBN_SELCHANGE(IDC_PORT_OUT1, OnSelchangePortOut1)
	ON_CBN_SELCHANGE(IDC_PORT_OUT2, OnSelchangePortOut2)
	ON_CBN_SELCHANGE(IDC_PORT_OUT3, OnSelchangePortOut3)
	ON_CBN_SELCHANGE(IDC_PORT_OUT4, OnSelchangePortOut4)
	ON_BN_CLICKED(IDC_PORT_OUT1_ENABLE, OnPortOut1Enable)
	ON_BN_CLICKED(IDC_PORT_OUT2_ENABLE, OnPortOut2Enable)
	ON_BN_CLICKED(IDC_PORT_OUT3_ENABLE, OnPortOut3Enable)
	ON_BN_CLICKED(IDC_PORT_OUT4_ENABLE, OnPortOut4Enable)
	ON_BN_CLICKED(IDC_KEY_RESET, OnKeyReset)
	ON_BN_CLICKED(IDC_CONTROLLER_RESET, OnControllerReset)
	ON_CBN_SELCHANGE(IDC_PORT_IN1_CHANNEL, OnSelchangePortIn1Channel)
	ON_CBN_SELCHANGE(IDC_PORT_IN2_CHANNEL, OnSelchangePortIn2Channel)
	ON_CBN_SELCHANGE(IDC_PORT_OUT1_CHANNEL, OnSelchangePortOut1Channel)
	ON_CBN_SELCHANGE(IDC_PORT_OUT2_CHANNEL, OnSelchangePortOut2Channel)
	ON_CBN_SELCHANGE(IDC_PORT_OUT3_CHANNEL, OnSelchangePortOut3Channel)
	ON_CBN_SELCHANGE(IDC_PORT_OUT4_CHANNEL, OnSelchangePortOut4Channel)
	ON_BN_CLICKED(IDC_PANIC, OnPanic)
	ON_BN_CLICKED(IDC_KEY_ACTIVE, OnKeyActive)
	ON_BN_CLICKED(IDC_CONTROLLER_ACTIVE, OnControllerActive)
	ON_LBN_DBLCLK(IDC_CONTROLLER_MAPPING, OnDblclkControllerMapping)
	ON_LBN_DBLCLK(IDC_KEY_MAPPING, OnDblclkKeyMapping)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BOOL MidiFishDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu *pSysMenu = GetSystemMenu(FALSE);

	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	SetWindowPos(NULL, theApp.GetProfileInt("Pos", "X", 32), theApp.GetProfileInt("Pos", "Y", 32), 0, 0, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOREDRAW | SWP_NOSIZE | SWP_NOZORDER);

	string filename = theApp.GetProfileString("Files", "Current");

	if (!filename.empty())
		mDoc->load(filename);

	set_title();

	GotoDlgCtrl(GetDlgItem(IDC_NONE));

	mTimer = SetTimer(1, 100, NULL);

	return FALSE;
}



void MidiFishDlg::set_title()
{
	CString title = "Midi Fish";

	if (!mDoc->mFilename.empty()) {
		CString f = mDoc->mFilename.c_str();

		f = f.Mid(f.ReverseFind('\\')+1);
		f = f.Mid(f.ReverseFind('/')+1);

		title += " - " + f;
	}

	SetWindowText(title);
}



static const char gFileFilter[] = "Midi Fish Files (*.mdf)|*.mdf|All Files (*.*)|*.*||";



void MidiFishDlg::OnOpen()
{
	CFileDialog dlg(true, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, gFileFilter, this);

	if (dlg.DoModal() == IDOK) {
		mDoc->load((const char *)dlg.GetPathName());
		set_title();
	}
}



void MidiFishDlg::OnSave() 
{
	if (mDoc->mFilename.empty()) {
		OnSaveas();
	}
	else {
		mDoc->save(mDoc->mFilename);
		set_title();
	}
}



void MidiFishDlg::OnSaveas() 
{
	CFileDialog dlg(false, "mdf", NULL, OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, gFileFilter, this);

	if (dlg.DoModal() == IDOK) {
		mDoc->save((const char *)dlg.GetPathName());
		set_title();
	}
}



void MidiFishDlg::OnCancel()
{
	if (mDoc->mDirty) {
		switch (AfxMessageBox("Save changes before quitting?", MB_YESNOCANCEL)) {

			case IDNO:
				break;

			case IDYES:
				OnSave();

				if (mDoc->mDirty)
					return;

				break;

			case IDCANCEL:
				return;
		}
	}

	RECT rc;

	GetWindowRect(&rc);

	theApp.WriteProfileInt("Pos", "X", rc.left);
	theApp.WriteProfileInt("Pos", "Y", rc.top);

	theApp.WriteProfileString("Files", "Current", mDoc->mFilename.c_str());

	CDialog::OnCancel();
}



void MidiFishDlg::OnDestroy() 
{
	KillTimer(mTimer);

	delete mDoc;
	mDoc = NULL;
	
	CDialog::OnClose();
}



void MidiFishDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	GotoDlgCtrl(GetDlgItem(IDC_NONE));
}



void MidiFishDlg::OnSelchangePortIn1() 
{
	int port = mIn1.GetCurSel() - 1;

	mDoc->mIn[0]->set(port, (port >= 0));
}



void MidiFishDlg::OnSelchangePortIn2() 
{
	int port = mIn2.GetCurSel() - 1;

	mDoc->mIn[1]->set(port, (port >= 0));
}



void MidiFishDlg::OnPortIn1Enable() 
{
	mDoc->mIn[0]->set(mDoc->mIn[0]->mPort, (mIn1Enable.GetCheck() != 0));
}



void MidiFishDlg::OnPortIn2Enable() 
{
	mDoc->mIn[1]->set(mDoc->mIn[1]->mPort, (mIn2Enable.GetCheck() != 0));
}



void MidiFishDlg::OnSelchangePortOut1() 
{
	int port = mOut1.GetCurSel() - 1;

	mDoc->mOut[0]->set(port, (port >= 0));
}



void MidiFishDlg::OnSelchangePortOut2() 
{
	int port = mOut2.GetCurSel() - 1;

	mDoc->mOut[1]->set(port, (port >= 0));
}



void MidiFishDlg::OnSelchangePortOut3() 
{
	int port = mOut3.GetCurSel() - 1;

	mDoc->mOut[2]->set(port, (port >= 0));
}



void MidiFishDlg::OnSelchangePortOut4() 
{
	int port = mOut4.GetCurSel() - 1;

	mDoc->mOut[3]->set(port, (port >= 0));
}



void MidiFishDlg::OnPortOut1Enable() 
{
	mDoc->mOut[0]->set(mDoc->mOut[0]->mPort, (mOut1Enable.GetCheck() != 0));
}



void MidiFishDlg::OnPortOut2Enable() 
{
	mDoc->mOut[1]->set(mDoc->mOut[1]->mPort, (mOut2Enable.GetCheck() != 0));
}



void MidiFishDlg::OnPortOut3Enable() 
{
	mDoc->mOut[2]->set(mDoc->mOut[2]->mPort, (mOut3Enable.GetCheck() != 0));
}



void MidiFishDlg::OnPortOut4Enable() 
{
	mDoc->mOut[3]->set(mDoc->mOut[3]->mPort, (mOut4Enable.GetCheck() != 0));
}



void MidiFishDlg::OnSelchangePortIn1Channel() 
{
	mDoc->mIn[0]->mChannel = mIn1Channel.GetCurSel() - 1;

	mDoc->mDirty = true;
}



void MidiFishDlg::OnSelchangePortIn2Channel() 
{
	mDoc->mIn[1]->mChannel = mIn2Channel.GetCurSel() - 1;

	mDoc->mDirty = true;
}



void MidiFishDlg::OnSelchangePortOut1Channel() 
{
	mDoc->mOut[0]->mChannel = mOut1Channel.GetCurSel() - 1;

	mDoc->mDirty = true;
}



void MidiFishDlg::OnSelchangePortOut2Channel() 
{
	mDoc->mOut[1]->mChannel = mOut2Channel.GetCurSel() - 1;

	mDoc->mDirty = true;
}



void MidiFishDlg::OnSelchangePortOut3Channel() 
{
	mDoc->mOut[2]->mChannel = mOut3Channel.GetCurSel() - 1;

	mDoc->mDirty = true;
}



void MidiFishDlg::OnSelchangePortOut4Channel() 
{
	mDoc->mOut[3]->mChannel = mOut4Channel.GetCurSel() - 1;

	mDoc->mDirty = true;
}



void MidiFishDlg::OnKeyReset() 
{
	if (AfxMessageBox("Reset key mapping?", MB_OKCANCEL) == IDOK)
		mDoc->reset_keys();
}



void MidiFishDlg::OnControllerReset() 
{
	if (AfxMessageBox("Reset controller mapping?", MB_OKCANCEL) == IDOK)
		mDoc->reset_controllers();
}



void MidiFishDlg::OnKeyActive() 
{
	mDoc->mKeyActive = (mKeyActive.GetCheck() != 0);

	mDoc->mDirty = true;
}



void MidiFishDlg::OnControllerActive() 
{
	mDoc->mCtrlActive = (mCtrlActive.GetCheck() != 0);

	mDoc->mDirty = true;
}



void MidiFishDlg::OnDblclkControllerMapping() 
{
	int sel = mCtrlMap.GetCurSel();

	if (sel < 0)
		return;

	CtrlMap *map = mDoc->mCtrlMap[sel];
	CtrlMap prev = *map;

	CtrlMapDlg dlg(map, mDoc);

	mDisableTimer = true;
	
	if (dlg.DoModal() == IDOK) {
		mDoc->mDirty = true;
		mDoc->update_ctrl_controls();
	}
	else
		*map = prev;

	mDisableTimer = false;
}



void MidiFishDlg::OnDblclkKeyMapping() 
{
	int sel = mKeyMap.GetCurSel();

	if (sel < 0)
		return;

	KeyMap *map = mDoc->mKeyMap[sel];
	KeyMap prev = *map;

	KeyMapDlg dlg(map, mDoc);

	mDisableTimer = true;

	if (dlg.DoModal() == IDOK) {
		mDoc->mDirty = true;
		mDoc->update_key_controls();
	}
	else
		*map = prev;

	mDisableTimer = false;
}



void MidiFishDlg::OnPanic() 
{
	for (int i=0; i<Doc::NUM_OUTS; i++)
		mDoc->mOut[i]->panic();
}



void MidiFishDlg::OnOK()
{
	CWnd *focus = GetFocus();

	if (focus == &mKeyMap)
		OnDblclkKeyMapping();
	else if (focus == &mCtrlMap)
		OnDblclkControllerMapping();
}



void MidiFishDlg::OnTimer(UINT nIDEvent) 
{
	if (mDisableTimer)
		return;

	CWnd *focus = GetFocus();

	// primary input selects keys
	int sel = mKeyMap.GetCurSel();

	if (focus == &mKeyMap) {
		if ((mDoc->mIn[0]->mRecentNote >= 0) && (sel != mDoc->mIn[0]->mRecentNote))
			mKeyMap.SetCurSel(mDoc->mIn[0]->mRecentNote);

		// secondary input edits the mapping
		if ((mDoc->mIn[1]->mRecentNote >= 0) && (mDoc->mKeyActive)) {
			if ((sel >= 0) && (mDoc->mKeyMap[sel]->mMap[0][0].mKey != mDoc->mIn[1]->mRecentNote)) {
				mDoc->mKeyMap[sel]->mMap[0][0].mKey = mDoc->mIn[1]->mRecentNote;
				mDoc->mDirty = true;
				mDoc->update_key_controls();
			}
		}

		// set output port for the second input
		if (sel >= 0)
			mDoc->mThruPort = mDoc->mKeyMap[sel]->mMap[0][0].mPort;
	}
	else {
		if (sel >= 0)
			mKeyMap.SetCurSel(-1);

		mDoc->mThruPort = 0;
	}

	// display controller inputs
	if (focus == &mCtrlMap) {
		if (mDoc->mIn[0]->mRecentController >= 0)
			mCtrlMap.SetCurSel(mDoc->mIn[0]->mRecentController);
		else if (mDoc->mIn[1]->mRecentController >= 0)
			mCtrlMap.SetCurSel(mDoc->mIn[1]->mRecentController);
	}
	else if (mCtrlMap.GetCurSel() >= 0)
		mCtrlMap.SetCurSel(-1);

	// clear
	mDoc->mIn[0]->mRecentNote = -1;
	mDoc->mIn[1]->mRecentNote = -1;

	mDoc->mIn[0]->mRecentController = -1;
	mDoc->mIn[1]->mRecentController = -1;
}



class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}



void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



void MidiFishDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else {
		CDialog::OnSysCommand(nID, lParam);
	}
}



void MidiFishDlg::OnPaint()
{
	if (IsIconic())	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
		CDialog::OnPaint();
	}
}



HCURSOR MidiFishDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

