// Key mapping class

#ifndef __KEYMAP_H__
#define __KEYMAP_H__



class KeyMap
{
public:
	// setup functions
	KeyMap(int key);

	static string get_name(int key);
	string get_desc();

	static const char *note(int key);
	static int octave(int key);


	// file IO
	void load(FILE *file);
	void save(FILE *file);


	// data
	enum { MAX_SPLITS = 4 };

	int mKey;

	int mSplitController[2];
	int mSplitCrossfade[2];

	int mSplitPoint[2][MAX_SPLITS+1];

	typedef struct Entry
	{
		int mKey;
		int mPort;
		int mVelScale;
		int mVelOffset;
	};

	Entry mMap[MAX_SPLITS][MAX_SPLITS];
};




#endif		// __KEYMAP_H__
